// ImageProcessingDoc.cpp : implementation of the CImageProcessingDoc class
//

#include "stdafx.h"
#include "ImageProcessing.h"

#include "ImageProcessingDoc.h"
#include "DownSampleDlg.h" // ȭڸ   
#include "UpSampleDlg.h" // ȭڸ   
#include "QuantizationDlg.h" // ȭڸ   
#include "math.h" //  Լ   

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CImageProcessingDoc

IMPLEMENT_DYNCREATE(CImageProcessingDoc, CDocument)

BEGIN_MESSAGE_MAP(CImageProcessingDoc, CDocument)
	//{{AFX_MSG_MAP(CImageProcessingDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImageProcessingDoc construction/destruction

CImageProcessingDoc::CImageProcessingDoc()
{
	// TODO: add one-time construction code here

}

CImageProcessingDoc::~CImageProcessingDoc()
{
}

BOOL CImageProcessingDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CImageProcessingDoc serialization

void CImageProcessingDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CImageProcessingDoc diagnostics

#ifdef _DEBUG
void CImageProcessingDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CImageProcessingDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CImageProcessingDoc commands

BOOL CImageProcessingDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	CFile File; //  ü

	File.Open(lpszPathName, CFile::modeRead | CFile::typeBinary);
	//   ̾α ڽ   ϰ б  

	if(File.GetLength() == 32*32){ // RAW  ũ 
			m_height = 32;
			m_width = 32;
		}
		else if(File.GetLength() == 64*64){ // RAW  ũ 
			m_height = 64;
			m_width = 64;
		}
		else if(File.GetLength() == 128*128){ // RAW  ũ 
			m_height = 128;
			m_width = 128;
		}
		else if(File.GetLength() == 256*256){ // RAW  ũ 
			m_height = 256;
			m_width = 256;
		}
		else if(File.GetLength() == 512*512){ // RAW  ũ 
			m_height = 512;
			m_width = 512;		
		}
		else if(File.GetLength() == 640*480){ // RAW  ũ 
			m_height = 480;
			m_width = 640;
		}
		else if(File.GetLength() == 176*144){// RAW  ũ 
			m_height = 144;
			m_width = 176;
		}
		else if(File.GetLength() == 176*216){ // RAW  ũ 
			m_height = 216;
			m_width = 176;
		}
		else{
			AfxMessageBox("Not Support Image Size"); //32*32, 64*64, 128*128, 256*256, 512*512, 640*480, 176*144 ũ ϸ 
			return 0;								 // Ÿ ̹ ũ ϶ 
		}

	m_size = m_width * m_height; //  ü ũ 

	m_InputImage = new unsigned char [m_size]; // Է  ũ⿡ ´ ޸ Ҵ
		
	for(int i = 0 ; i<m_size ; i++)
		m_InputImage[i] = 255;
		
	File.Read(m_InputImage, m_size); // Է   б  
	File.Close(); //  ݱ
	
	return TRUE;
}

BOOL CImageProcessingDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	CFile File;
	CFileDialog SaveDlg(FALSE, "raw", NULL, OFN_HIDEREADONLY);

	if(SaveDlg.DoModal() == IDOK){ // DoModal Լ Ͽ ϱ⸦ 
		File.Open(SaveDlg.GetPathName(), CFile::modeCreate | CFile::modeWrite);
		File.Write(m_OutputImage, m_Re_size); //  
		File.Close(); //  ݱ
	}
	
	return TRUE; 
}


void CImageProcessingDoc::OnDownSampling()
{
	int i, j;

	CDownSampleDlg dlg;
	
	if(dlg.DoModal() == IDOK)
	{
		m_Re_height = m_height / dlg.m_DownSampleRate; //     
		m_Re_width = m_width / dlg.m_DownSampleRate; //    ̸ 
		m_Re_size = m_Re_height * m_Re_width; //   ũ⸦ 

		m_OutputImage = new unsigned char [m_Re_size]; //    ޸ Ҵ

		for(i=0 ; i<m_Re_size ; i++)
			m_OutputImage[i] = 255;

		for(i=0 ; i<m_Re_height ; i++){
			for(j=0 ; j<m_Re_width ; j++){
				m_OutputImage[i*m_Re_width + j] = m_InputImage[(i*dlg.m_DownSampleRate*m_width) + dlg.m_DownSampleRate*j];
				// ٿ ø  
			}
		}
	}
}

void CImageProcessingDoc::OnUpSampling()
{
	int i,j;

	CUpSampleDlg dlg;

	if(dlg.DoModal() == IDOK){ // DoModal  Լ Ȱȭ 
		m_Re_height = m_height * dlg.m_UpSampleRate; // Ȯ    
		m_Re_width = m_width * dlg.m_UpSampleRate; // Ȯ    
		m_Re_size = m_Re_height * m_Re_width; // Ȯ  ũ 
			
		m_OutputImage = new unsigned char[m_Re_size]; // Ȯ   ޸ Ҵ


		for(i=0 ; i<m_Re_size ; i++)
			m_OutputImage[i] = 0; // ʱȭ
	
		for(i=0 ; i<m_height ; i++){
			for(j=0 ; j<m_width ; j++){
				m_OutputImage[i*dlg.m_UpSampleRate*m_Re_width + dlg.m_UpSampleRate*j] = m_InputImage[i*m_width + j];
				// ġ   Ȯ
			}
		}		
	}
}

void CImageProcessingDoc::OnQuantization()
{
	CQuantizationDlg dlg;

	if(dlg.DoModal() == IDOK) // ȭ Ʈ ϴ ȭ Ȱȭ 
	{
		m_Re_height = m_height;
		m_Re_width = m_width;
		m_Re_size = m_Re_height * m_Re_width;

		m_OutputImage = new unsigned char[m_Re_size];
		// ȭ ó  ϱ  ޸ Ҵ

		int i, j, value, LEVEL;
		double HIGH, *TEMP;

		TEMP = new double [m_size];
			
		LEVEL=256; // Է  ȭ ܰ
		HIGH=256.;

		value = (int)pow(2, dlg.m_QuantBit); // Է  ȭ ܰ

		for(i=0 ; i<m_size ; i++){
			for(j=0 ; j<value ; j++){
				if(m_InputImage[i]>=(LEVEL/value)*j && m_InputImage[i]<(LEVEL/value)*(j+1)){
					TEMP[i]=(double)(HIGH/value)*j;
					// ȭ 
				}
			}
		}

		for(i=0 ; i<m_Re_size ; i++){
			m_OutputImage[i] = (unsigned char)TEMP[i]; //  
		}
	}
}



