// ImageProcessingView.cpp : implementation of the CImageProcessingView class
//

#include "stdafx.h"
#include "ImageProcessing.h"

#include "ImageProcessingDoc.h"
#include "ImageProcessingView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CImageProcessingView

IMPLEMENT_DYNCREATE(CImageProcessingView, CView)

BEGIN_MESSAGE_MAP(CImageProcessingView, CView)
	//{{AFX_MSG_MAP(CImageProcessingView)
	ON_COMMAND(ID_DOWN_SAMPLING, OnDownSampling)
	ON_COMMAND(ID_UP_SAMPLING, OnUpSampling)
	ON_COMMAND(ID_QUANTIZATION, OnQuantization)
	ON_COMMAND(ID_SUM_CONSTANT, OnSumConstant)
	ON_COMMAND(ID_SUB_CONSTANT, OnSubConstant)
	ON_COMMAND(ID_MUL_CONSTANT, OnMulConstant)
	ON_COMMAND(ID_DIV_CONSTANT, OnDivConstant)
	ON_COMMAND(ID_NEGA_TRANSFORM, OnNegaTransform)
	ON_COMMAND(ID_BINARIZATION, OnBinarization)
	ON_COMMAND(ID_GAMMA_CORRECTION, OnGammaCorrection)
	ON_COMMAND(ID_STRESS_TRANSFORM, OnStressTransform)
	ON_COMMAND(ID_AND_OPERATE, OnAndOperate)
	ON_COMMAND(ID_OR_OPERATE, OnOrOperate)
	ON_COMMAND(ID_XOR_OPERATE, OnXorOperate)
	ON_COMMAND(ID_HISTOGRAM, OnHistogram)
	ON_COMMAND(ID_HISTO_EQUAL, OnHistoEqual)
	ON_COMMAND(ID_HISTO_STRETCH, OnHistoStretch)
	ON_COMMAND(ID_HISTO_SPEC, OnHistoSpec)
	ON_COMMAND(ID_END_IN_SEARCH, OnEndInSearch)
	ON_COMMAND(ID_EMBOSSING, OnEmbossing)
	ON_COMMAND(ID_BLURR, OnBlurr)
	ON_COMMAND(ID_GAUSSIAN_FILTER, OnGaussianFilter)
	ON_COMMAND(ID_SHARPENING, OnSharpening)
	ON_COMMAND(ID_HPF_SHARP, OnHpfSharp)
	ON_COMMAND(ID_LPF_SHARP, OnLpfSharp)
	ON_COMMAND(ID_DIFF_OPERATOR_HOR, OnDiffOperatorHor)
	ON_COMMAND(ID_DIFF_OPERATOR_VER, OnDiffOperatorVer)
	ON_COMMAND(ID_HOMOGEN_OPERATOR, OnHomogenOperator)
	ON_COMMAND(ID_LAPLACIAN, OnLaplacian)
	ON_COMMAND(ID_NEAREST, OnNearest)
	ON_COMMAND(ID_BILINEAR, OnBilinear)
	ON_COMMAND(ID_MEDIAN_SUB, OnMedianSub)
	ON_COMMAND(ID_MEAN_SUB, OnMeanSub)
	ON_COMMAND(ID_TRANSLATION, OnTranslation)
	ON_COMMAND(ID_MIRROR_HOR, OnMirrorHor)
	ON_COMMAND(ID_MIRROR_VER, OnMirrorVer)
	ON_COMMAND(ID_ROTATION, OnRotation)
	ON_COMMAND(ID_FRAME_SUM, OnFrameSum)
	ON_COMMAND(ID_FRAME_SUM_B, OnFrameSumB)
	ON_COMMAND(ID_FRAME_SUB, OnFrameSub)
	ON_COMMAND(ID_FRAME_MUL, OnFrameMul)
	ON_COMMAND(ID_FRAME_DIV, OnFrameDiv)
	ON_COMMAND(ID_FRAME_AND, OnFrameAnd)
	ON_COMMAND(ID_FRAME_OR, OnFrameOr)
	ON_COMMAND(ID_FRAME_XOR, OnFrameXor)
	ON_COMMAND(ID_FRAME_COMB, OnFrameComb)
	ON_COMMAND(ID_BINARY_EROSION, OnBinaryErosion)
	ON_COMMAND(ID_BINARY_DILATION, OnBinaryDilation)
	ON_COMMAND(ID_GRAY_EROSION, OnGrayErosion)
	ON_COMMAND(ID_GRAY_DILATION, OnGrayDilation)
	ON_COMMAND(ID_LOW_PASS_FILTER, OnLowPassFilter)
	ON_COMMAND(ID_HIGH_PASS_FILTER, OnHighPassFilter)
	ON_COMMAND(ID_MEAN_FILTER, OnMeanFilter)
	ON_COMMAND(ID_MEDIAN_FILTER, OnMedianFilter)
	ON_COMMAND(ID_MAX_FILTER, OnMaxFilter)
	ON_COMMAND(ID_MIN_FILTER, OnMinFilter)
	ON_COMMAND(ID_FFT_2D, OnFft2d)
	ON_COMMAND(ID_IFFT_2D, OnIfft2d)
	ON_COMMAND(ID_LPF_FREQUENCY, OnLpfFrequency)
	ON_COMMAND(ID_HPF_FREQUENCY, OnHpfFrequency)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImageProcessingView construction/destruction

CImageProcessingView::CImageProcessingView()
{
	// TODO: add construction code here

}

CImageProcessingView::~CImageProcessingView()
{
}

BOOL CImageProcessingView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CImageProcessingView drawing

void CImageProcessingView::OnDraw(CDC* pDC)
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here

	// OnDraw : ȭ鿡  ϴ Լ
	int i,j;
	unsigned char R, G, B;
	
	for(i = 0 ; i<pDoc->m_height ; i++){
		for(j = 0 ; j<pDoc->m_width ; j++){
			R = pDoc->m_InputImage[i*pDoc->m_width+j];
			G = B = R;
			pDC->SetPixel(j+5, i+5, RGB(R, G, B));
		}
	}

	for(i = 0 ; i<pDoc->m_Re_height ; i++){
		for(j = 0 ; j<pDoc->m_Re_width ; j++){
			R = pDoc->m_OutputImage[i*pDoc->m_Re_width+j];
			G = B = R;
			pDC->SetPixel(j+pDoc->m_width+10, i+5, RGB(R, G, B));
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// CImageProcessingView printing

BOOL CImageProcessingView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CImageProcessingView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CImageProcessingView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CImageProcessingView diagnostics

#ifdef _DEBUG
void CImageProcessingView::AssertValid() const
{
	CView::AssertValid();
}

void CImageProcessingView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CImageProcessingDoc* CImageProcessingView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CImageProcessingDoc)));
	return (CImageProcessingDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CImageProcessingView message handlers





void CImageProcessingView::OnDownSampling() 
{
	// TODO: Add your command handler code here
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnDownSampling();

	Invalidate(TRUE);
}

void CImageProcessingView::OnUpSampling() 
{
	// TODO: Add your command handler code here
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnUpSampling();

	Invalidate(TRUE);
}

void CImageProcessingView::OnQuantization() 
{
	// TODO: Add your command handler code here
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnQuantization();

	Invalidate(TRUE);
}

void CImageProcessingView::OnSumConstant() 
{
	// TODO: Add your command handler code here
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnSumConstant();

	Invalidate(TRUE);
}

void CImageProcessingView::OnSubConstant() 
{
	// TODO: Add your command handler code here
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnSubConstant();

	Invalidate(TRUE);
}

void CImageProcessingView::OnMulConstant() 
{
	// TODO: Add your command handler code here
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnMulConstant();

	Invalidate(TRUE);
}

void CImageProcessingView::OnDivConstant() 
{
	// TODO: Add your command handler code here
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnDivConstant();

	Invalidate(TRUE);
}

void CImageProcessingView::OnNegaTransform() 
{
	// TODO: Add your command handler code here
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnNegaTransform();

	Invalidate(TRUE);
}

void CImageProcessingView::OnBinarization() 
{
	// TODO: Add your command handler code here
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnBinarization();

	Invalidate(TRUE);	
}

void CImageProcessingView::OnGammaCorrection() 
{
	// TODO: Add your command handler code here
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnGammaCorrection();

	Invalidate(TRUE);
}

void CImageProcessingView::OnStressTransform() 
{
	// TODO: Add your command handler code here
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnStressTransform();

	Invalidate(TRUE);
}

void CImageProcessingView::OnAndOperate() 
{
	// TODO: Add your command handler code here
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnAndOperate();

	Invalidate(TRUE);
}

void CImageProcessingView::OnOrOperate() 
{
	// TODO: Add your command handler code here
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnOrOperate();

	Invalidate(TRUE);
}

void CImageProcessingView::OnXorOperate() 
{
	// TODO: Add your command handler code here
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnXorOperate();

	Invalidate(TRUE);
}


void CImageProcessingView::OnHistogram() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnHistogram();

	Invalidate(TRUE);
}

void CImageProcessingView::OnHistoEqual() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnHistoEqual();

	Invalidate(TRUE);
}

void CImageProcessingView::OnHistoStretch() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnHistoStretch();

	Invalidate(TRUE);
}

void CImageProcessingView::OnHistoSpec() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnHistoSpec();

	Invalidate(TRUE);
}

void CImageProcessingView::OnEndInSearch() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnEndInSearch();

	Invalidate(TRUE);
}

void CImageProcessingView::OnEmbossing() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnEmbossing();

	Invalidate(TRUE);
}

void CImageProcessingView::OnBlurr() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnBlurr();

	Invalidate(TRUE);
}

void CImageProcessingView::OnGaussianFilter() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnGaussianFilter();

	Invalidate(TRUE);
}

void CImageProcessingView::OnSharpening() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnSharpening();

	Invalidate(TRUE);	
}

void CImageProcessingView::OnHpfSharp() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnHpfSharp();

	Invalidate(TRUE);	
}

void CImageProcessingView::OnLpfSharp() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnLpfSharp();

	Invalidate(TRUE);
}


void CImageProcessingView::OnDiffOperatorHor() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnDiffOperatorHor();

	Invalidate(TRUE);	
}

void CImageProcessingView::OnDiffOperatorVer() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnDiffOperatorVer();

	Invalidate(TRUE);
}

void CImageProcessingView::OnHomogenOperator() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnHomogenOperator();

	Invalidate(TRUE);
}



void CImageProcessingView::OnLaplacian() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnLaplacian();

	Invalidate(TRUE);
}

void CImageProcessingView::OnNearest() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnNearest();

	Invalidate(TRUE);
}

void CImageProcessingView::OnBilinear() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnBilinear();

	Invalidate(TRUE);
}

void CImageProcessingView::OnMedianSub() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnMedianSub();

	Invalidate(TRUE);
}

void CImageProcessingView::OnMeanSub() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnMeanSub();

	Invalidate(TRUE);
}

void CImageProcessingView::OnTranslation() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnTranslation();

	Invalidate(TRUE);	
}

void CImageProcessingView::OnMirrorHor() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnMirrorHor();

	Invalidate(TRUE);
}

void CImageProcessingView::OnMirrorVer() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnMirrorVer();

	Invalidate(TRUE);
}

void CImageProcessingView::OnRotation() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnRotation();

	Invalidate(TRUE);
}

void CImageProcessingView::OnFrameSum() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnFrameSum();

	Invalidate(TRUE);	
}

void CImageProcessingView::OnFrameSumB() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnFrameSumB();

	Invalidate(TRUE);
}

void CImageProcessingView::OnFrameSub() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnFrameSub();

	Invalidate(TRUE);
}

void CImageProcessingView::OnFrameMul() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnFrameMul();

	Invalidate(TRUE);
}

void CImageProcessingView::OnFrameDiv() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnFrameDiv();

	Invalidate(TRUE);
}

void CImageProcessingView::OnFrameAnd() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnFrameAnd();

	Invalidate(TRUE);
}

void CImageProcessingView::OnFrameOr() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnFrameOr();

	Invalidate(TRUE);
}

void CImageProcessingView::OnFrameXor() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnFrameXor();

	Invalidate(TRUE);	
}

void CImageProcessingView::OnFrameComb() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnFrameComb();

	Invalidate(TRUE);
}

void CImageProcessingView::OnBinaryErosion() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnBinaryErosion();

	Invalidate(TRUE);
}

void CImageProcessingView::OnBinaryDilation() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnBinaryDilation();

	Invalidate(TRUE);
}

void CImageProcessingView::OnGrayErosion() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnGrayErosion();

	Invalidate(TRUE);
}

void CImageProcessingView::OnGrayDilation() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnGrayDilation();

	Invalidate(TRUE);
}

void CImageProcessingView::OnLowPassFilter() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnLowPassFilter();

	Invalidate(TRUE);
}

void CImageProcessingView::OnHighPassFilter() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnHighPassFilter();

	Invalidate(TRUE);
}

void CImageProcessingView::OnMeanFilter() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnMeanFilter();

	Invalidate(TRUE);
}

void CImageProcessingView::OnMedianFilter() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnMedianFilter();

	Invalidate(TRUE);
}

void CImageProcessingView::OnMaxFilter() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnMaxFilter();

	Invalidate(TRUE);
}

void CImageProcessingView::OnMinFilter() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnMinFilter();

	Invalidate(TRUE);
}

void CImageProcessingView::OnFft2d() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnFft2d();

	Invalidate(TRUE);
	
}

void CImageProcessingView::OnIfft2d() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnIfft2d();

	Invalidate(TRUE);
}

void CImageProcessingView::OnLpfFrequency() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnLpfFrequency();

	Invalidate(TRUE);
}

void CImageProcessingView::OnHpfFrequency() 
{
	CImageProcessingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->OnHpfFrequency();

	Invalidate(TRUE);
	
}
